#include<unistd.h>
#include<stdio.h>
#include<signal.h>

void sig_handle(int sig)
{
    switch (sig)
    {
        case SIGUSR1 : printf("sig_handle::get SIGUSR1:%d\n", sig); break;
        case SIGUSR2 : printf("sig_handle::get SIGUSR2:%d\n", sig); break;
        default      : printf("sig_handle::get signal :%d\n", sig); break;
    }
}

int main(int argc, char ** argv)
{
    printf("sgtest::getpid()::%d\n", (int)getpid());

    if (signal(SIGUSR1, sig_handle) == SIG_ERR) 
    { 
        perror("signal SIGUSR1 register error"); 
        return 1; 
    }

    if (signal(SIGUSR2, sig_handle) == SIG_ERR) 
    { 
        perror("signal SIGUSR2 register error"); 
        return 1; 
    }

    while(1)
    {
        // 我们将sleep放置到while循环中，
        // 是因为当信号来临时，sleep被信号中断，然后sleep会马上返回
        // 如果sleep不在while循环中，那么该程序执行完信号响应函数之后，会马上执行到底，从而整体退出
        int ileft = sleep(10); // ileft表示被中断后，sleep执行中的剩余时间
                               // man 3 sleep : Zero if the requested time has elapsed, 
                               // or the number of seconds left to sleep, if the call was interrupted by a signal handler.
		
        printf("ileft:%d\n", ileft);
    }

    return 0;
}
